Package: Guerry
Type: Package
Title: Maps, Data and Methods Related to Guerry (1833) "Moral
        Statistics of France"
Version: 1.8.3
Date: 2023-10-24
Authors@R: c(
             person(given = "Michael", 
                   family = "Friendly", 
                   role=c("aut", "cre"), 
                   email="friendly@yorku.ca",
                   comment = c(ORCID = "0000-0002-3237-0941")),
             person(given = "Stephane", 
                   family = "Dray", 
                   role="aut", 
                   email="stephane.dray@univ-lyon1.fr",
                   comment = c(ORCID = "0000-0003-0153-1105")),
             person(given = "Roger", 
                   family = "Bivand", 
                   role="ctb",
                   email = "Roger.Bivand@nhh.no")
            )
Maintainer: Michael Friendly <friendly@yorku.ca>
Encoding: UTF-8
Language: en-US
Depends: R (>= 3.5.0)
Imports: sp
Suggests: knitr, sf, spdep, ade4, adegraphics, adespatial,
        RColorBrewer, corrgram, car, effects, rmarkdown, here, ggplot2,
        ggpcp, ggrepel, heplots, patchwork, candisc, colorspace,
        scales, remotes, dplyr, tidyr
Description: Maps of France in 1830, multivariate datasets from A.-M. Guerry and others, and statistical and 
	graphic methods related to Guerry's "Moral Statistics of France". The goal is to facilitate the exploration and
	development of statistical and graphic methods for multivariate data in a geospatial context of historical interest.
License: GPL
URL: https://github.com/friendly/Guerry
BugReports: https://github.com/friendly/Guerry/issues
LazyLoad: yes
LazyData: yes
VignetteBuilder: knitr
NeedsCompilation: no
Packaged: 2023-10-24 16:55:48 UTC; friendly
Author: Michael Friendly [aut, cre] (<https://orcid.org/0000-0002-3237-0941>),
  Stephane Dray [aut] (<https://orcid.org/0000-0003-0153-1105>),
  Roger Bivand [ctb]
Repository: CRAN
Date/Publication: 2023-10-24 20:20:10 UTC
Built: R 4.6.0; ; 2026-04-25 19:26:00 UTC; unix

Package: Guerry
Type: Package
Title: Maps, Data and Methods Related to Guerry (1833) "Moral
        Statistics of France"
Version: 1.8.3
Date: 2023-10-24
Authors@R: c(
             person(given = "Michael", 
                   family = "Friendly", 
                   role=c("aut", "cre"), 
                   email="friendly@yorku.ca",
                   comment = c(ORCID = "0000-0002-3237-0941")),
             person(given = "Stephane", 
                   family = "Dray", 
                   role="aut", 
                   email="stephane.dray@univ-lyon1.fr",
                   comment = c(ORCID = "0000-0003-0153-1105")),
             person(given = "Roger", 
                   family = "Bivand", 
                   role="ctb",
                   email = "Roger.Bivand@nhh.no")
            )
Maintainer: Michael Friendly <friendly@yorku.ca>
Encoding: UTF-8
Language: en-US
Depends: R (>= 3.5.0)
Imports: sp
Suggests: knitr, sf, spdep, ade4, adegraphics, adespatial,
        RColorBrewer, corrgram, car, effects, rmarkdown, here, ggplot2,
        ggpcp, ggrepel, heplots, patchwork, candisc, colorspace,
        scales, remotes, dplyr, tidyr
Description: Maps of France in 1830, multivariate datasets from A.-M. Guerry and others, and statistical and 
	graphic methods related to Guerry's "Moral Statistics of France". The goal is to facilitate the exploration and
	development of statistical and graphic methods for multivariate data in a geospatial context of historical interest.
License: GPL
URL: https://github.com/friendly/Guerry
BugReports: https://github.com/friendly/Guerry/issues
LazyLoad: yes
LazyData: yes
VignetteBuilder: knitr
NeedsCompilation: no
Packaged: 2023-10-24 16:55:48 UTC; friendly
Author: Michael Friendly [aut, cre] (<https://orcid.org/0000-0002-3237-0941>),
  Stephane Dray [aut] (<https://orcid.org/0000-0003-0153-1105>),
  Roger Bivand [ctb]
Repository: CRAN
Date/Publication: 2023-10-24 20:20:10 UTC
Built: R 4.6.0; ; 2026-04-26 19:33:30 UTC; unix

#' ---
#' title: MANOVA, candisc models for Guerry data
#' ---


#' Load packages

library(heplots)
library(candisc, warn.conflicts = FALSE)
library(car)
library(Guerry)
library(dplyr)
#library(sp)

data(Guerry, package="Guerry")

#' ## extract pieces
df           <- data.frame(Guerry)[, 4:9]        # the 6 variables
dep.names    <- data.frame(Guerry)[, 3]          # departement names
region.names <- data.frame(Guerry)[, 2]          # region names
col.region   <- colors()[c(149, 254, 468, 552, 26)] # colors for region


#' ## MANOVA: What variables predict crime?
crime.mod <- lm(cbind(Crime_pers, Crime_prop) ~ 
                Region + Literacy + Donations +  Infants + Suicides, data=Guerry)
Anova(crime.mod)

#' ## bivariate confidence intervals for coefficients
coefplot(crime.mod, fill = TRUE, fill.alpha = 0.1, level=0.68)

coefplot(crime.mod, fill = TRUE, fill.alpha = 0.1, level=0.68, parm = 6:9)


#' ## diagnostic plot for multivariate normality and outliers
labels <- paste0(Guerry$dept,":", Guerry$Department)
cqplot(crime.mod, id.n=4, labels=labels)

heplot(crime.mod, 
       fill=TRUE, fill.alpha=0.05, 
       cex=1.4, cex.lab=1.3
      )


#' ## Canonical discriminant analysis
crime.can <- candisc(crime.mod)
crime.can
#plot(crime.can)

heplot(crime.can, fill=TRUE, fill.alpha=0.1,
       var.col = "black", 
       var.cex = 1.3,
       cex=1.4, cex.lab=1.3)

#' ## Use ranks
#' Guerry recognized the extreme skewness of some variables and so used ranks on these measures

Guerry_ranks <- Guerry |>
  select(1:9) |>
  mutate(
    Crime_pers = dense_rank(Crime_pers),
    Crime_prop = dense_rank(Crime_prop),
    Literacy   = dense_rank(Literacy),
    Donations  = dense_rank(Donations),
    Infants    = dense_rank(Infants),
    Suicides   = dense_rank(Suicides)
  )

# Guerry_ranks <- Guerry |> 
#   select(1:9) |>
#   mutate(across(Crime_pers:Suicides, dense_rank))
    

crime.modr <- lm(cbind(Crime_pers, Crime_prop) ~ 
                  Region + Literacy + Donations +  Infants + Suicides, data=Guerry_ranks)
Anova(crime.modr)

heplot(crime.modr, 
       fill=TRUE, fill.alpha=0.05, 
       cex=1.4, cex.lab=1.2
)

crime.canr <- candisc(crime.modr)
crime.canr
#plot(crime.can)

heplot(crime.canr)



#' ## What variables discriminate among Regions ?

region.mod <- lm(cbind(Crime_pers, Crime_prop, Literacy, Donations, Infants, Suicides) ~ 
                   Region, data=Guerry)
Anova(region.mod)

heplot(region.mod, fill=TRUE, fill.alpha=0.1)

pairs(region.mod, variables=1:3, fill=TRUE, fill.alpha=0.1)

region.can <- candisc(region.mod)
region.can
plot(region.can)

#' ---
#' title: Density plots of Guerry data
#' ---

library(dplyr)     # A Grammar of Data Manipulation
library(tidyr)     # tidy methods
library(ggplot2)   # Create Elegant Data Visualisations Using the Grammar of Graphics
library(scales)    # Scale Functions for Visualization
library(Guerry)    # Maps, Data and Methods Related to Guerry (1833) "Moral Statistics of France"

data("Guerry", package="Guerry")

#' ## Convert to long format
guerry_long <- Guerry |>
  filter(!is.na(Region)) |>
  select(dept:Suicides) |>
  pivot_longer(cols = Crime_pers:Suicides,
               names_to = "variable",
               values_to = "value")
guerry_long

#' ## density plot of each variable
ggplot(data = guerry_long,
       aes(x=value, fill=TRUE)) +
  geom_density(alpha=0.2) +
  geom_rug() +
  facet_wrap(~variable, scales="free") +
  theme_bw(base_size = 14) +
  theme(legend.position = "none",
        axis.ticks.y=element_blank(),
        axis.text.y=element_blank())

#' ## by region
col.region   <- colors()[c(149, 254, 468, 552, 26)] # colors for region
ggplot(data = guerry_long,
       aes(x=value, fill=Region)) +
  geom_density(alpha=0.2) +
  geom_rug() +
  facet_wrap(~variable, scales="free") +
  scale_fill_manual(values=col.region) +
  theme_bw(base_size = 14) +
  theme(legend.position = "bottom",
        axis.ticks.y=element_blank(),
        axis.text.y=element_blank())

     

#' ---
#' title: Bivariate data ellipses for crime rates vs. literacy
#' ---
#' 

library(Guerry)
library(car)
data(Guerry)

set.seed(12315)
with(Guerry,{
	dataEllipse(Literacy, Crime_pers/1000,
		levels = 0.68,
  	ylim = c(0,40000), xlim = c(0, 80),
  	ylab="Pop. per crime against persons",
  	xlab="Percent who can read & write",
  	pch = 16,
  	grid = FALSE,
  	id = list(method="mahal", 
  	          n = 8, 
  	          labels=Department, 
  	          location="avoid", cex=1.2),
  	center.pch = 3, center.cex=5,
  	cex.lab=1.5)
	dataEllipse(Literacy, Crime_pers/1000,
		levels = 0.95, add=TRUE,
#  	ylim = c(0,40000), xlim = c(0, 80),
  	lwd=2, lty="longdash",
  	col="gray",
  	center.pch = FALSE
  	)
  
  abline( lm(Crime_pers ~ Literacy), lwd=2)	
  lines(loess.smooth(Literacy, Crime_pers), col="red", lwd=3)
  }
  	)

with(Guerry,{
  dataEllipse(Literacy, Crime_prop,
              levels = 0.68,
              ylim = c(0,20000), xlim = c(0, 80),
              ylab="Pop. per crime against poperty",
              xlab="Percent who can read & write",
              pch = 16,
              grid = FALSE,
              id = list(method="mahal", 
                        n = 8, 
                        labels=Department, 
                        location="avoid", cex=1.2),
              center.pch = 3, center.cex=5,
              cex.lab=1.5)
  dataEllipse(Literacy, Crime_prop,
              levels = 0.95, add=TRUE,
              ylim = c(0,40000), xlim = c(0, 80),
              lwd=2, lty="longdash",
              col="gray",
              center.pch = FALSE
  )
  
  abline( lm(Crime_prop ~ Literacy), lwd=2)	
  lines(loess.smooth(Literacy, Crime_prop), col="red", lwd=3)
}
)



# redo this as crimes per 100,000 persons

Guerry$Crime_pers_rate <- 100000 / Guerry$Crime_pers

set.seed(12315)
with(Guerry,{
	dataEllipse(Literacy, Crime_pers_rate,
		levels = 0.68,
  	ylim = c(-5,45), 
		xlim = c(-5, 80),
  	ylab = "Crimes against persons / 100k pop",
  	xlab="Percent who can read & write",
  	pch = 16,
  	grid = FALSE,
  	id = list(method="mahal", 
  	          n = 8, 
  	          labels=Department, 
  	          location="avoid", cex=1.2),
  	center.pch = 3, center.cex=5,
  	cex.lab=1.5)
	dataEllipse(Literacy, Crime_pers_rate,
		levels = 0.95, add=TRUE,
  	ylim = c(-5,45), 
  	xlim = c(-5, 80),
  	lwd=2, lty="longdash",
  	col="gray",
  	center.pch = FALSE
  	)
  
  abline( lm(Crime_pers_rate ~ Literacy), lwd=2)	
  lines(loess.smooth(Literacy, Crime_pers_rate), col="red", lwd=3)
  }
  	)

#' ---
#' title: Predicting crime, multiple regression
#' ---

library(car)
library(effects)

#' ## Fit models predicting crime variables
crime.mod1 <- lm(Crime_pers ~  Region + Literacy + Donations +  Infants + Suicides, data=Guerry)
crime.mod2 <- lm(Crime_prop ~  Region + Literacy + Donations +  Infants + Suicides, data=Guerry)

Anova(crime.mod1)
Anova(crime.mod2)

#' ## diagnostic plots
op <- par(mfrow=c(2,2))
plot(crime.mod1)
par(op)

op <- par(mfrow=c(2,2))
plot(crime.mod2)
par(op)


#' ## Effect plots

plot(predictorEffects(crime.mod1, ~ Region + Literacy + Infants + Suicides), lwd=2, main="")
plot(predictorEffects(crime.mod2, ~ Region + Literacy + Infants + Suicides), lwd=2)

## ----setup, include = FALSE---------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  warning = FALSE,
  message = FALSE,   # suppress package loading messages
  comment = "#>",
  fig.height = 5,
  fig.width = 5,
  dpi = 96
)

# packages to be cited here. Code at the end automatically updates packages.bib
to.cite <- c("car", "effects", "ggplot2", "GGally", "ggbiplot")


## ----load---------------------------------------------------------------------
library(Guerry)         # Guerry data
library(car)            # better scatterplots
library(effects)        # Effect Displays for Linear Models
library(ggplot2)        # Elegant Data Visualisations Using the Grammar of Graphics
library(ggrepel)        # better handling of text labels
library(patchwork)      # combine plots
library(heplots)        # Hypothesis-Error plots
library(candisc)        # Visualizing Generalized Canonical Discriminant Analysis
library(dplyr)          # A Grammar of Data Manipulation
library(tidyr)          # Tidy Messy Data
data(Guerry)

## ----guerry-more-vars---------------------------------------------------------
names(Guerry)[-(1:9)]

## ----guerry-long--------------------------------------------------------------
data("Guerry", package="Guerry")
guerry_long <- Guerry |>
  filter(!is.na(Region)) |>
  select(dept:Suicides) |>
  pivot_longer(cols = Crime_pers:Suicides,
               names_to = "variable",
               values_to = "value")
guerry_long

## ----guerry-density1----------------------------------------------------------
ggplot(data = guerry_long,
       aes(x=value, fill=TRUE)) +
  geom_density(alpha=0.2) +
  geom_rug() +
  facet_wrap(~variable, scales="free") +
  theme_bw(base_size = 14) +
  theme(legend.position = "none",
        axis.ticks.y=element_blank(),
        axis.text.y=element_blank())

## ----guerry-density2----------------------------------------------------------
col.region   <- colors()[c(149, 254, 468, 552, 26)] # colors for region
ggplot(data = guerry_long,
       aes(x=value, fill=Region)) +
  geom_density(alpha=0.2) +
  geom_rug() +
  facet_wrap(~variable, scales="free") +
  scale_fill_manual(values=col.region) +
  theme_bw(base_size = 14) +
  theme(legend.position = "bottom",
        axis.ticks.y=element_blank(),
        axis.text.y=element_blank())


## ----lit-pers-scat0-----------------------------------------------------------
ggplot(aes(x=Literacy, y=Crime_pers/1000), data=Guerry) +
  geom_point(size=2) 


## ----lit-pers-scat------------------------------------------------------------
gdf <- Guerry[, c("Literacy", "Crime_pers", "Department")]
gdf$dsq <- mahalanobis(gdf[,1:2], colMeans(gdf[,1:2]), cov(gdf[,1:2]))

ggplot(aes(x=Literacy, y=Crime_pers/1000, label=Department), data=gdf) +
  geom_point(size=2) +
  stat_ellipse(level=0.68, color="blue", size=1.2) +  
  stat_ellipse(level=0.95, color="gray", size=1, linetype=2) + 
  geom_smooth(method="lm", formula=y~x, fill="lightblue") +
  geom_smooth(method="loess", formula=y~x, color="red", se=FALSE) +
  geom_label_repel(data = gdf[gdf$dsq > 4.6,]) +
  theme_bw()

## ----lit-prop-scat------------------------------------------------------------
gdf <- Guerry[, c("Literacy", "Crime_prop", "Department")]
gdf$dsq <- mahalanobis(gdf[,1:2], colMeans(gdf[,1:2]), cov(gdf[,1:2]))

ggplot(aes(x=Literacy, y=Crime_prop/1000, label=Department), data=gdf) +
  geom_point(size=2) +
  stat_ellipse(level=0.68, color="blue", size=1.2) +  
  stat_ellipse(level=0.95, color="gray", size=1, linetype=2) + 
  geom_smooth(method="lm", formula=y~x, fill="lightblue") +
  geom_smooth(method="loess", formula=y~x, color="red", se=FALSE) +
  geom_label_repel(data = gdf[gdf$dsq > 4.6,]) +
  theme_bw()

## ----spm1---------------------------------------------------------------------
par(mar=rep(2,4))
library(car)          # Companion to Applied Regression
scatterplotMatrix(Guerry[,4:9],
                  ellipse=list(levels=0.68), 
                  smooth=FALSE)

## ----corrgram1----------------------------------------------------------------
par(mar=rep(1,4)+.1)
library(corrgram)             # Plot a Correlogram
corrgram(Guerry[,4:9], upper=panel.pie)

## ----corrgram2----------------------------------------------------------------
par(mar=rep(1,4)+.1)
corrgram(Guerry[,4:9], 
         upper=panel.ellipse, 
         order=TRUE,
         lwd=2)

## ----guerry.pca---------------------------------------------------------------
gdata <- Guerry |>
  select(Region, Crime_pers:Suicides) |>   # keep only main variables
  filter(!is.na(Region))                   # delete Corsica (Region==NA)

guerry.pca <- gdata |>
  select(-Region) |>
  prcomp(scale = TRUE)

print(guerry.pca, digits=3)


## ----biplot1------------------------------------------------------------------
#  if(!require(ggbiplot)) remotes::install_github("vqv/ggbiplot")
#  library(ggbiplot) # A ggplot2 based biplot
#  ggbiplot(guerry.pca, groups=gdata$Region,
#           ellipse=TRUE,
#           var.scale = 3, varname.size = 5) +
#    theme_bw() +
#    labs(color="Region") +
#    theme(legend.position = c(0.1, 0.8))

## ----ggbiplot-----------------------------------------------------------------
knitr::include_graphics("figures/ggbiplot.png")

## ----biplot2, out.width="95%"-------------------------------------------------
op <- par(mar=c(5,4,1,1)+.1)
cols = colorspace::rainbow_hcl(5)
covEllipses(guerry.pca$x, 
            group=gdata$Region, 
            pooled=FALSE, 
            fill=TRUE, fill.alpha=0.1,
            col=cols, 
            label.pos=c(3,0,1,1,3), 
            cex=2,
            xlim=c(-4,4), ylim=c(-4,4),
            xlab = "Dimension 1 (35.7 %)", 
            ylab = "Dimension 2 (20.0 %)",
            cex.lab=1.4
            )
points(guerry.pca$x, pch=(15:19)[Guerry$Region], col=cols[Guerry$Region])

candisc::vectors(guerry.pca$rotation, scale=5,  
                 col="black", lwd=3, cex=1.4, 
                 pos = c(4,2,4,2,2,2),
                 xpd=TRUE)
abline(h=0, v=0, col=gray(.70))

## ----mra-models---------------------------------------------------------------
crime.mod1 <- lm(Crime_pers ~  Region + Literacy + Donations +  Infants + Suicides, data=Guerry)
crime.mod2 <- lm(Crime_prop ~  Region + Literacy + Donations +  Infants + Suicides, data=Guerry)

## ----mra-anova----------------------------------------------------------------
Anova(crime.mod1)
Anova(crime.mod2)

## ----mra-effect1-code---------------------------------------------------------
#  plot(predictorEffects(crime.mod1, ~ Region + Literacy + Infants + Suicides),
#       lwd=2, main="")

## ----mra-effect1--------------------------------------------------------------
knitr::include_graphics("figures/mra-effect1.png")

## ----mra-effect2-code---------------------------------------------------------
#  plot(predictorEffects(crime.mod2, ~ Region + Literacy + Infants + Suicides),
#       lwd=2, main="")

## ----mra-effect2--------------------------------------------------------------
knitr::include_graphics("figures/mra-effect2.png")

## ----manova1------------------------------------------------------------------
crime.mod <- lm(cbind(Crime_pers, Crime_prop) ~ 
                Region + Literacy + Donations +  Infants + Suicides, data=Guerry)
Anova(crime.mod)

## ----cqplot-------------------------------------------------------------------
par(mar=c(3,3,1,1)+.1)
labels <- paste0(Guerry$dept,":", Guerry$Department)
cqplot(crime.mod, id.n=4, labels=labels)

## ----heplot-------------------------------------------------------------------
par(mar = c(3,3,1,1)+.1)
heplot(crime.mod, 
       fill=TRUE, fill.alpha=0.05, 
       cex=1.4, cex.lab=1.3 )

## ----candisc------------------------------------------------------------------
crime.can <- candisc(crime.mod)
crime.can

## ----hecan--------------------------------------------------------------------
par(mar = c(3,3,1,1)+.1)
heplot(crime.can, fill=TRUE, fill.alpha=0.1,
       var.col = "black", 
       var.cex = 1.3,
       cex=1.4, cex.lab=1.3)

## ----write-bib, echo = FALSE--------------------------------------------------
# write a packages.bib file of the packages (.packages()) that have been used here
pkgs <- unique(c(to.cite, .packages()))
knitr::write_bib(pkgs, file = here::here("vignettes", "packages.bib"))

---
title: "Guerry data: Spatial Multivariate Analysis"
author: "Stéphane Dray"
date: "`r Sys.Date()`"
output: 
  rmarkdown::html_vignette:
    toc: true
    toc_depth: 2
bibliography: reference.bib
link-citations: yes
vignette: >
  %\VignetteIndexEntry{Guerry data: Spatial Multivariate Analysis}
  %\VignetteKeywords{crime, literacy, suicide, France, spatial multivariate analysis}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r setup, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  warning = FALSE,
  message = FALSE,   # suppress package loading messages
  comment = "#>",
  fig.height = 3,
  fig.width = 3,
  fig.align = "center"
)
```

This vignette indicates how to perform the analyses described in @SD966 of data derived from André-Michel Guerry's [-@SD955] *Essai sur la Statistique Morale de la France*. 
It illustrates some classical methods for analysis of multivariate spatial data that focus *either* on the multivariate aspect or on the spatial one, as well as some more modern methods that attempt to integrate geographical and multivariate aspects *simultaneously*. 

# Preliminary steps

Several packages are required to run the different analyses and should be loaded. The `ade4` package for multivariate
analysis is supplemented by `adegraphics` (for associated graphical methods) and `adespatial` for multivariate spatial analysis. For further information on this spatial analysis approach, see
`vignette(package="adespatial", "tutorial")`.


```{r}
library(Guerry)       # Guerry's data
library(sp)           # management of spatial data
library(ade4)         # multivariate analysis
library(adegraphics)  # graphical representation
library(spdep)        # spatial dependency
library(adespatial)   # multivariate spatial analysis
```

Guerry gathered data on crimes, suicide, literacy and other moral statistics for various départements (i.e., counties) in France. He provided the first real social data analysis, using graphics and maps to summarize this georeferenced multivariate dataset. We use the dataset `gfrance85` and consider six key quantitative variables (shown in the table below) for each of the 85 départements of France in 1830 (Corsica, an island and often an outlier, was excluded). 

Data are recorded on aligned scales so that **larger numbers** consistently
reflect "morally better". Thus, four of the "bad" variables are recorded in the inverse form, as
"Population per ...". With this scaling, it would be expected that all correlations be $\ge 0$.


| Name        | Description |
|:------------|:------------|
|`Crime_pers` | Population per crime against persons|
|`Crime_prop` | Population per crime against property|
|`Literacy`   | Percent of military conscripts who can read and write|
|`Donations`  | Donations to the poor|
|`Infants`    | Population per illegitimate birth|
|`Suicides`   | Population per suicide|

The dataset `gfrance85` is actually a `SpatialPolygonsDataFrame` object created with the `sp` package.
It contains the polygon boundaries of the map of France in 1830, as well the variables in the `Guerry` data frame.
As an ordinary data.frame, it has these components
```{r names}
names(gfrance85)
```

To simplify analyses, we extract the components to be used below.  

```{r components}
 data(gfrance85)
 df           <- data.frame(gfrance85)[, 7:12]    # the 6 variables
 france.map   <- as(gfrance85, "SpatialPolygons") # the map
 xy           <- coordinates(gfrance85)           # spatial coordinates
 dep.names    <- data.frame(gfrance85)[, 6]       # departement names
 region.names <- data.frame(gfrance85)[, 5]       # region names
 col.region   <- colors()[c(149, 254, 468, 552, 26)] # colors for region
```

# Standard approaches

In this section, we focus on classical approaches that consider either the multivariate or the spatial aspect of the data. 

## Multivariate analysis

Here we consider $p=6$ variables measured for $n=85$ individuals (départements of France). As only quantitative variables have been recorded, principal component analysis [PCA, @SD308] is well adapted. PCA summarizes the data by maximizing simultaneously the variance of the projection of the individuals onto the principal axes and the sum of the squared correlations between the principal component and the variables.

```{r dudi-pca}
pca <- dudi.pca(df, scannf = FALSE, nf = 3)
```

The biplot is simply obtained by

```{r}
biplot(pca, plabel.cex = 0.8)
```

The first two PCA dimensions account for 35.7% and 20% ,respectively, of the total variance.

```{r}
pca$eig/sum(pca$eig) * 100
```

Correlations between variables and principal components can be represented on a correlation circle. The first axis is negatively correlated to literacy and positively correlated to property crime, suicides and illegitimate births. The second axis is aligned mainly with personal crime and donations to the poor.

```{r}
s.corcircle(pca$co)
```

Spatial information can be added on the factorial map representing the projections of départements on principal axes by coloring according to colors representing the different regions of France.

```{r, fig.width = 4, fig.height  = 4}
s.label(pca$li, ppoint.col = col.region[region.names], plabel.optim = TRUE, plabel.cex = 0.6)
s.Spatial(france.map, col = col.region[region.names], plabel.cex = 0)
s.class(xy, region.names, col = col.region, add = TRUE, ellipseSize = 0, starSize = 0)
```

For the first axis, the North and East are characterized by negative scores, corresponding to high levels of literacy and high rates of suicides, crimes against property and illegitimate births. The second axis mainly contrasts the West (high donations to the the poor and low levels of crime against persons) to the South. 

## Spatial autocorrelation

Spatial autocorrelation statistics, such as @SD455 Coefficient (MC) and @SD223 Ratio, aim to measure and analyze the degree of dependency among observations in a geographical context [@SD577]. 

### The spatial weighting matrix

The first step of spatial autocorrelation analysis is to define a spatial weighting matrix $\mathbf{W}=[w_{ij}]$ . In the case of Guerry's data, we simply defined a binary neighborhood where two départements are considered as neighbors if they share a common border. The spatial weighting matrix is then obtained after row-standardization (`style = "W"`):

```{r}
nb <- poly2nb(gfrance85)
lw <- nb2listw(nb, style = "W")
```

We can represent this neighborhood on the geographical map:

```{r}
s.Spatial(france.map, nb = nb, plabel.cex = 0, pSp.border = "white")
```

### Moran's Coefficient

Once the spatial weights have been defined, the spatial autocorrelation statistics can then be computed. Let us consider the $n$-by-1 vector $\mathbf{x}=\left[ {x_1 \cdots x_n } \right]^\textrm{T}$ containing measurements of a quantitative variable for $n$ spatial units. The usual formulation for Moran's coefficient of spatial autocorrelation [@SD577;@SD455] is
\begin{equation}
\label{eq1}
MC(\mathbf{x})=\frac{n\sum\nolimits_{\left( 2 \right)} {w_{ij} (x_i -\bar 
{x})(x_j -\bar {x})} }{\sum\nolimits_{\left( 2 \right)} {w_{ij} } 
\sum\nolimits_{i=1}^n {(x_i -\bar {x})^2} }\mbox{ where 
}\sum\nolimits_{\left( 2 \right)} =\sum\limits_{i=1}^n {\sum\limits_{j=1}^n 
} \mbox{ with }i\ne j.
\end{equation}

MC can be rewritten using matrix notation:
\begin{equation}
\label{eq2}
MC(\mathbf{x})=\frac{n}{\mathbf{1}^\textrm{T}\mathbf{W1}}\frac{\mathbf{z}^\textrm{T}{\mathbf{Wz}}}{\mathbf{z}^\textrm{T}\mathbf{z}},
\end{equation}
where $\mathbf{z}=\left ( \mathbf{I}_n-\mathbf{1}_n\mathbf{1}_n^\textrm{T} /n \right )\mathbf{x}$ is the vector of centered values ($z_i=x_i-\bar{x}$) and $\mathbf{1}_n$ is a vector of ones (of length $n$).

 The significance of the observed value of MC can be tested by a Monte-Carlo procedure, in which locations are permuted to obtain a distribution of MC under the null hypothesis of random distribution. An observed value of MC that is greater than that expected at random indicates the clustering of similar values across space (positive spatial autocorrelation), while a significant negative value of MC indicates that neighboring values are more dissimilar than expected by chance (negative spatial autocorrelation).

We computed MC for the Guerry's dataset. A positive and significant autocorrelation is identified for each of the six variables. Thus, the values of literacy are the most covariant in adjacent departments, while illegitimate births (Infants) covary least.

```{r}
moran.randtest(df, lw)
```

### Moran scatterplot

If the spatial weighting matrix is row-standardized, we can define the lag vector $\mathbf{\tilde{z}} = \mathbf{Wz}$ (i.e., $\tilde{z}_i = \sum\limits_{j=1}^n{w_{ij}x_j}$) composed of the weighted (by the spatial weighting matrix) averages of the neighboring values. Thus, we have:
\begin{equation}
\label{eq3}
MC(\mathbf{x})=\frac{\mathbf{z}^\textrm{T}{\mathbf{\tilde{z}}}}{\mathbf{z}^\textrm{T}\mathbf{z}},
\end{equation}
since in this case $\mathbf{1}^\textrm{T}\mathbf{W1}=n$. This shows clearly that MC measures the autocorrelation by giving an indication of the intensity of the linear association between the vector of observed values $\mathbf{z}$ and the vector of weighted averages of neighboring values $\mathbf{\tilde{z}}$. @SD566 proposed to visualize MC in the form of a bivariate scatterplot of $\mathbf{\tilde{z}}$ against $\mathbf{z}$. A linear regression can be added to this *Moran scatterplot*, with slope equal to MC.

Considering the Literacy variable of Guerry's data, the Moran scatterplot clearly shows strong autocorrelation. It also shows that the Hautes-Alpes département has a slightly outlying position characterized by a high value of Literacy compared to its neighbors.

```{r, fig.width = 4, fig.height=4}
x <- df[, 3]
x.lag <- lag.listw(lw, df[, 3])
moran.plot(x, lw)
text(x[5], x.lag[5], dep.names[5], pos = 1, cex = 0.8)
```

## Indirect integration of multivariate and geographical aspects

The simplest approach considered a two-step procedure where the data are first summarized with multivariate analysis such as PCA. In a second step, univariate spatial statistics or mapping techniques are applied to PCA scores for each axis separately. One can also test for the presence of spatial autocorrelation for the first few scores of the analysis, with univariate autocorrelation statistics such as MC. We mapped scores of the départements for the first two axes of the PCA of Guerry's data. Even if PCA maximizes only the variance of these scores, there is also a clear spatial structure, as the scores are highly autocorrelated. The map for the first axis corresponds closely to the split between *la France éclairée* (North-East characterized by an higher level of Literacy) and *la France obscure*.

```{r, fig.dim = c(6,3)}
moran.randtest(pca$li, lw)
s.value(xy, pca$li[, 1:2], Sp = france.map, pSp.border = "white", symbol = "circle", pgrid.draw = FALSE)
```

# Spatial multivariate analysis

Over the last decades, several approaches have been developed to consider both geographical and multivariate information simultaneously. The multivariate aspect is usually treated by techniques of dimensionality reduction similar to PCA. On the other hand, several alternatives have been proposed to integrate the spatial information. 

## Spatial partition

One alternative is to consider a spatial partition of the study area. In this case, the spatial information is coded as a categorical variable, and each category corresponds to a region of the whole study area. For instance, Guerry's data contained a partition of France into 5 regions.

We used the between-class analysis [BCA, @SD148], to investigate differences between regions. BCA maximizes the variance between groups.

```{r}
 bet <- bca(pca, region.names, scannf = FALSE, nf = 2)
```

Here, 28.8 % of the total variance (sum of eigenvalues of PCA) corresponds to the between-regions variance (sum of the eigenvalues of BCA).

```{r}
bet$ratio
```

The main graphical outputs are obtained by the generic `plot` function:

```{r, fig.dim=c(5,5)}
plot(bet)
```

The barplot of eigenvalues indicates that two axes should be interpreted. The first two BCA dimensions account for 59 % and 30.2 %, respectively, of the between-regions variance.

```{r}
 barplot(bet$eig)
 bet$eig/sum(bet$eig) * 100
```

The coefficients used to construct the linear combinations of variables are represented:

```{r}
s.arrow(bet$c1, plabel.cex = 0.8)
```

The first axis opposed literacy to property crime, suicides and illegitimate births. The second axis is mainly aligned with personal crime and donations to the poor.

Projections of départements on the BCA axes can be represented on the factorial map:

```{r, fig.dim = c(4,4)}
s.label(bet$ls, as.character(dep.names), ppoint.cex = 0, plabel.optim = TRUE, plabel.col = col.region[region.names], plabel.cex = 0.5)
s.class(bet$ls, fac = region.names, col = col.region, ellipse = 0, add = TRUE)
```

The scores can be mapped to show the spatial aspects:

```{r, fig.dim = c(6,3)}
s.value(xy, bet$ls, symbol = "circle", Sp = france.map, pSp.col = col.region[region.names], pSp.border = "transparent")
```

The results are very close to those obtained by PCA: the first axis contrasted the North and the East (*la France éclairée*) to the other regions while the South is separated from the other regions by the second axis. The high variability of the region Centre is also noticeable. In contrast, the South is very homogeneous. 

## Spatial explanatory variables

<!-- deleted @PCAIV - not in references -->
Principal component analysis with respect to the instrumental variables [PCAIV, @SD540], and related methods, have been often used in community ecology to identify spatial relationships. The spatial information is introduced in the form of spatial predictors and the analysis maximized the "spatial variance" (i.e., the variance explained by spatial predictors).  Note that BCA can also be considered as a particular case of PCAIV, where the explanatory variables are dummy variables indicating group membership.

### Trend surface of geographic coordinates

@SD626 proposed to express observed values in time series as a polynomial function of time, and mentioned that this could be done for spatial data as well. @SD59 extended this approach to the spatial and multivariate case by introducing polynomial functions of geographic coordinates as predictors in PCAIV. We call this approach PCAIV-POLY. 

The centroids of départements of France were used to construct a second-degree orthogonal polynomial.

```{r, fig.dim = c(6,4)}
poly.xy <- orthobasis.poly(xy, degree = 2)
s.value(xy, poly.xy, Sp = france.map, plegend.drawKey = FALSE)
```

PCAIV is then performed using the `pcaiv` function:

```{r}
pcaiv.xy <- pcaiv(pca, poly.xy, scannf = FALSE, nf = 2)

```

Here, 32.4 % of the total variance (sum of eigenvalues of PCA) is explained by the second-degree polynomial (sum of eigenvalues of PCAIV). The first two dimensions account for 51.4 % and 35.2 %, respectively, of the explained variance. 

```{r}
sum(pcaiv.xy$eig)/sum(pca$eig) * 100
pcaiv.xy$eig/sum(pcaiv.xy$eig) * 100
```

The outputs of PCAIV-POLY (coefficients of variables, maps of départements scores, etc.) are very similar to those obtained by BCA. They can be represented easily by the generic `plot` function:

```{r, fig.dim=c(5,5)}
plot(pcaiv.xy)
```

### Moran's eigenvector maps

An alternative way to build spatial predictors is by the diagonalization of the spatial weighting matrix **W**. Moran's eigenvector maps [MEM, @SD163] are the $n-1$ eigenvectors of the doubly-centered matrix **W**. They are orthogonal vectors with a unit norm maximizing MC [@SD264]. MEM associated with high positive (or negative) eigenvalues have high positive (or negative) autocorrelation. MEM associated with eigenvalues with small absolute values correspond to low spatial autocorrelation, and are not suitable for defining spatial structures.

We used the spatial weighting matrix defined above to construct MEM. The first ten MEM, corresponding to the highest levels of spatial autocorrelation, have been mapped:

```{r, fig.dim = c(6,6)}
mem1 <- scores.listw(lw)
s.value(xy, mem1[, 1:9], Sp = france.map, plegend.drawKey = FALSE)

```

We introduced the first ten MEM as spatial explanatory variables in PCAIV. We call this approach PCAIV-MEM. 

```{r}
pcaiv.mem <- pcaiv(pca, mem1[,1:10], scannf = FALSE)
```

Here, 44.1 % of the total variance (sum of eigenvalues of PCA) is explained by the first ten MEM (sum of eigenvalues of PCAIV). The first two dimensions account for 54.9 % and 26.3 %, respectively, of the explained variance.

```{r}
sum(pcaiv.mem$eig)/sum(pca$eig) * 100
pcaiv.mem$eig/sum(pcaiv.mem$eig) * 100
```

The outputs of PCAIV-MEM (coefficients of variables, maps of départements scores, etc.) are very similar to those obtained by BCA. They can be represented easily by the generic `plot` function:

```{r, fig.dim=c(5,5)}
plot(pcaiv.mem)
```

## Spatial graph and  weighting matrix

The MEM framework introduced the spatial information into multivariate analysis through the eigendecomposition of the spatial weighting matrix. Usually, we consider only a part of the information contained in this matrix because only a subset of MEM are used as regressors in PCAIV. In this section, we focus on multivariate methods that consider the spatial weighting matrix under its original form. 

@SD694 was the first to develop a multivariate analysis based on MC. His work considered only normed and centered variables (i.e., normed PCA) for the multivariate part and a binary symmetric connectivity matrix for the spatial aspect. @SD807 generalized Wartenberg's method by introducing a row-standardized spatial weighting matrix in the analysis of a statistical triplet. This approach is very general and allows us to define spatially-constrained versions of various methods (corresponding to different triplets) such as correspondence analysis or multiple correspondence analysis. MULTISPATI finds coefficients to obtain a linear combination of variables that maximizes a compromise between the classical multivariate analysis and a generalized version of Moran's coefficient. 

```{r}
 ms <- multispati(pca, lw, scannf = FALSE)
```

The main outputs of MULTISPATI can be represented easily by the generic `plot` function:

```{r, fig.dim=c(5,5)}
plot(ms)
```

The barplot of eigenvalues suggests two main spatial structures. Eigenvalues of MULTISPATI are the product between the variance and the spatial autocorrelation of the scores, while PCA maximizes only the variance. The differences between the two methods are computed by the `summary` function:

```{r}
summary(ms)
```
Hence, there is a loss of variance compared to PCA (2.14 versus 2.017 for axis 1; 1.201 versus 1.177 for axis 2) but a gain of spatial autocorrelation (0.551 versus 0.637 for axis 1; 0.561 versus 0.59 for axis 2).


Coefficients of variables allow to interpret the structures:

```{r}
s.arrow(ms$c1, plabel.cex = 0.8)
```

The first axis opposes literacy to property crime, suicides and illegitimate births. The second axis is aligned mainly with personal crime and donations to the poor. The maps of the scores show that the spatial structures are very close to those identified by PCA. The similarity of results between PCA and its spatially optimized version confirm that the main structures of Guerry's data are spatial.

Spatial autocorrelation can be seen as the link between one variable and the lagged vector. This interpretation is used to construct the Moran scatterplot and can be extended to the multivariate case in  MULTISPATI by analyzing the link between scores and lagged scores: 

```{r, fig.dim = c(4,4)}
s.match(ms$li, ms$ls, plabel.cex = 0)
s.match(ms$li[c(10, 41, 27), ], ms$ls[c(10, 41, 27), ], label = dep.names[c(10, 
     41, 27)], plabel.cex = 0.8, add = TRUE)
```

Each département can be represented on the factorial map by an arrow (the bottom corresponds to its score, the head corresponds to its lagged score. A short arrow reveals a local spatial similarity (between one plot and its neighbors) while a long arrow reveals a spatial discrepancy. This viewpoint can be interpreted as a multivariate extension of the local index of spatial association [@SD565]. For instance:
* Aude has a very small arrow, indicating that this département is very similar to its neighbors.
* Haute-Loire has a long horizontal arrow which reflects its high values for the variables Infants (31017), Suicides (163241) and Crime\_prop (18043) compared to the average values over its neighbors (27032.4, 60097.8 and 10540.8 for these three variables).
* Finistère corresponds to an arrow with a long vertical length which is due to its high values compared to its neighbors for Donations (23945 versus 12563) and Crime\_pers (29872 versus 25962).

The link between the scores and the lagged scores (averages of neighbors weighted by the spatial connection matrix) can be mapped in the geographical space. For the first two axes, we have:

```{r, fig.dim = c(6,3)}
s.value(xy, ms$li, Sp = france.map)
```

# Conclusions 

Even if the methods presented are quite different in their theoretical and practical viewpoints, their applications to Guerry's dataset yield very similar results. We provided a quantitative measure of this similarity by computing Procrustes statistics [@SD516;SD161] between the scores of the départements onto the first two axes for the different analyses. All the values of the statistic are very high and significant; this confirms the high concordance between the outputs of the different methods. 

```{r}
mat <- matrix(NA, 4, 4)
mat.names <- c("PCA", "BCA", "PCAIV-POLY", "PCAIV-MEM", "MULTISPATI")
colnames(mat) <- mat.names[-5]
rownames(mat) <- mat.names[-1]

mat[1, 1] <- procuste.randtest(pca$li[, 1:2], bet$ls[, 1:2])$obs
mat[2, 1] <- procuste.randtest(pca$li[, 1:2], pcaiv.xy$ls[, 1:2])$obs
mat[3, 1] <- procuste.randtest(pca$li[, 1:2], pcaiv.mem$ls[, 1:2])$obs
mat[4, 1] <- procuste.randtest(pca$li[, 1:2], ms$li[, 1:2])$obs
mat[2, 2] <- procuste.randtest(bet$ls[, 1:2], pcaiv.xy$ls[, 1:2])$obs
mat[3, 2] <- procuste.randtest(bet$ls[, 1:2], pcaiv.mem$ls[, 1:2])$obs
mat[4, 2] <- procuste.randtest(bet$ls[, 1:2], ms$li[, 1:2])$obs
mat[3, 3] <- procuste.randtest(pcaiv.xy$ls[, 1:2], pcaiv.mem$ls[, 1:2])$obs
mat[4, 3] <- procuste.randtest(pcaiv.xy$ls[, 1:2], ms$li[, 1:2])$obs
mat[4, 4] <- procuste.randtest(pcaiv.mem$ls[, 1:2], ms$li[, 1:2])$obs

mat
```


# References

---
title: "Guerry data: Multivariate Analysis"
author: "Michael Friendly"
date: "`r Sys.Date()`"
package: Guerry
output: 
  rmarkdown::html_vignette:
    toc: true
    toc_depth: 2
bibliography: ["refs.bib", "packages.bib"]
link-citations: yes
vignette: >
  %\VignetteIndexEntry{Guerry data: Multivariate Analysis}
  %\VignetteKeywords{crime, literacy, suicide, France, multivariate analysis}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r setup, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  warning = FALSE,
  message = FALSE,   # suppress package loading messages
  comment = "#>",
  fig.height = 5,
  fig.width = 5,
  dpi = 96
)

# packages to be cited here. Code at the end automatically updates packages.bib
to.cite <- c("car", "effects", "ggplot2", "GGally", "ggbiplot")

```

André-Michel Guerry's _Essai sur la Statistique Morale de la France_ [@Guerry:1833]
collected data on crimes, suicide, literacy and other "moral statistics" for various départements
in France. He provided the first real social data analysis, using graphics and maps to summarize this
multivariate dataset. One of his main goals in this ground-breaking study was to determine if the prevalence
of crime in France could be explained by other social variables.

In 1833, the scatterplot had not yet been invented; the idea of a correlation or a regression was still 50 years
in the future [@Galton:1886]. Guerry displayed his data in shaded choropleth maps and semi-graphic tables
and argued how these could be seen as implying systematic, lawful relations among moral variables.

In this analysis, we ignore the spatial context of the départements and focus on multivariate analyses of the
the data set.

# Load data and packages

We will primarily use the following packages, so load them now.
```{r load}
library(Guerry)         # Guerry data
library(car)            # better scatterplots
library(effects)        # Effect Displays for Linear Models
library(ggplot2)        # Elegant Data Visualisations Using the Grammar of Graphics
library(ggrepel)        # better handling of text labels
library(patchwork)      # combine plots
library(heplots)        # Hypothesis-Error plots
library(candisc)        # Visualizing Generalized Canonical Discriminant Analysis
library(dplyr)          # A Grammar of Data Manipulation
library(tidyr)          # Tidy Messy Data
data(Guerry)
```

## `Guerry` data set

Guerry's (1833) data consisted of six main moral variables shown in the table below. 
He wanted all of these to be recorded on aligned scales so that **larger** numbers consistently
reflected "**morally better**". Thus, four of the variables are recorded in the inverse form,
as "Population per ...".


| Name        | Description                                          |
|:------------|:-----------------------------------------------------|
|`Crime_pers` | Population per crime against persons                 |
|`Crime_prop` | Population per crime against property                |
|`Literacy`   | Percent of military conscripts who can read and write|
|`Donations`  | Donations to the poor                                |
|`Infants`    | Population per illegitimate birth                    |
|`Suicides`   | Population per suicide                               |

The `Guerry` data set also contains:

* `dept` and `Department`, the French ID numbers and names for the 86 départements of metropolitan France in 1830, including Corsica.
* `Region`: a factor with main levels "N", "S", "E", "W", "C". Corsica is coded as `NA`.
* A collection of 14 other related variables from other sources at the same time. See `?Guerry` for their precise definitions.

```{r guerry-more-vars}
names(Guerry)[-(1:9)]
```

Among these, as other aspects of criminal behavior,  we see crime against parents,  `Infanticide` and `Prostitutes`. `Clergy` and `Donations_clergy` are considered to be measures of moral rectitude,
potentially counteracting crime.

## Guerry's questions

The main questions that concerned Guerry were whether indicators of crime could be shown to be related to factors
which might be considered to ameliorate crime. Among these, Guerry focused most on `Literacy` defined as the
number of military conscripts who could do more than mark an "X" on their enrollment form.
A related variable is `Instruction`, the rank recorded from Guerry's map;
as defined, it is inversely related to `Literacy`.

Other potential explanatory variables are:

: `Donations`   (a measure of donations to the poor),
: `Donation_clergy` (a measure of donations to clergy)
: `Clergy` (the rank of number of Catholic priests in active service, per population)


# Multivariate visualization methods

Visualization methods for multivariate data take an enormous variety of forms simply because more than two dimensions of data offer exponentially increasingly possibilities.  It is useful to distinguish several broad categories:

* __data plots__ : primarily plot the raw data, often with annotations to aid interpretation (regression lines and smooths, data ellipses, marginal distributions)

* __model plots__ : primarily plot the results of a fitted model, considering that
the fitted model may involve more variables than can be shown in a static 2D plot.
Some examples are: Added variable plots, effect plots, coefficient plots, ...

* __diagnostic plots__ : indicating potential problems with the fitted model. These include residual plots, influence plots, plots for testing homogeneity of variance and so forth.

* __dimension reduction plots__ : plot representations of the data into a space of fewer dimensions than the number of variables in the data set. Simple examples include principal components analysis (PCA) and the related biplots,
and multidimensional scaling (MDS) methods.

# Data plots

Data plots portray the data in a space where the coordinate axes are the observed variables.

*   1D plots include line plots, histograms and density estimates
*   2D plots are most often scatterplots, but contour plots or hex-binned plots are also useful when the sample size is large.
*   For higher dimensions, biplots, showing the data in principal components space, together with vectors representing the correlations among variables, are often the most useful.

<!-- ```{r child = "../man/partials/_ggradar.Rmd"} -->
<!-- ``` -->

## Density plots

It is useful to examine the distributions of the variables and **density** plots are 
quite informative. I want to do this for each of the 6 main variables, so I'll use
this trick of tidy data analysis with `ggplot2`:

1. Reshape the data from wide to long. This gives `guerry_long`, where the different variables are in a column labeled `variable` and the values are in `value`.


```{r guerry-long}
data("Guerry", package="Guerry")
guerry_long <- Guerry |>
  filter(!is.na(Region)) |>
  select(dept:Suicides) |>
  pivot_longer(cols = Crime_pers:Suicides,
               names_to = "variable",
               values_to = "value")
guerry_long
```

2. Plot the density, but make a different subplot by `facet_wrap(~ variable)`. These plots all have different scales for the X and Y (density) values, so it is important to use `scales="FREE"`.
Moreover, I'm primarily interested in the **shape** of these distributions, so I suppress the Y
axis tick marks and labels.

```{r guerry-density1}
#| out.width = "100%"
ggplot(data = guerry_long,
       aes(x=value, fill=TRUE)) +
  geom_density(alpha=0.2) +
  geom_rug() +
  facet_wrap(~variable, scales="free") +
  theme_bw(base_size = 14) +
  theme(legend.position = "none",
        axis.ticks.y=element_blank(),
        axis.text.y=element_blank())
```

You can see that all variables are positively skewed, `Donations`, `Infants` and `Suicides` particularly so, but not so much as to cause alarm.

It is also of interest to see whether and how these distributions differ according to `Region`.
This is easy to do, using `aes(... fill=Region)`

```{r guerry-density2}
#| out.width = "100%",
#| fig.height = 6
col.region   <- colors()[c(149, 254, 468, 552, 26)] # colors for region
ggplot(data = guerry_long,
       aes(x=value, fill=Region)) +
  geom_density(alpha=0.2) +
  geom_rug() +
  facet_wrap(~variable, scales="free") +
  scale_fill_manual(values=col.region) +
  theme_bw(base_size = 14) +
  theme(legend.position = "bottom",
        axis.ticks.y=element_blank(),
        axis.text.y=element_blank())

```
For some variables, like `Infants` and `Suicides` the differences do not seem particularly
large.  However, both crime variables and `Literacy` show marked differences across region.

## Bivariate relations

Let's start with plots of crime (`Crime_pers` and `Crime_prop`) in relation to `Literacy`.
A simple scatterplot is not very informative. All that can be seen is that there is not much of a relation between personal crime and literacy.

```{r lit-pers-scat0}
ggplot(aes(x=Literacy, y=Crime_pers/1000), data=Guerry) +
  geom_point(size=2) 

```


More useful scatterplots are annotated with additional
statistical summaries to aid interpretation:

* linear regression line,
* smoothed non-parametric (loess) curve, to diagnose potential non-linear relations,
* data ellipses, to highlight the overall trend and variability,
* point labels for potentially outlying or influential points.

I use `ggplot2` here.  It provides most of these features, except that
to label unusual points, I calculate the Mahalanobis squared distance
of all points from the grand means.

```{r lit-pers-scat}
gdf <- Guerry[, c("Literacy", "Crime_pers", "Department")]
gdf$dsq <- mahalanobis(gdf[,1:2], colMeans(gdf[,1:2]), cov(gdf[,1:2]))

ggplot(aes(x=Literacy, y=Crime_pers/1000, label=Department), data=gdf) +
  geom_point(size=2) +
  stat_ellipse(level=0.68, color="blue", size=1.2) +  
  stat_ellipse(level=0.95, color="gray", size=1, linetype=2) + 
  geom_smooth(method="lm", formula=y~x, fill="lightblue") +
  geom_smooth(method="loess", formula=y~x, color="red", se=FALSE) +
  geom_label_repel(data = gdf[gdf$dsq > 4.6,]) +
  theme_bw()
```

The flat (blue) regression line and the nearly circular data ellipses show that the correlation is nearly zero; the smoothed (red) curve indicates that there is no tendency for a nonlinear relation.

Doing the same for crimes against property:
```{r lit-prop-scat}
gdf <- Guerry[, c("Literacy", "Crime_prop", "Department")]
gdf$dsq <- mahalanobis(gdf[,1:2], colMeans(gdf[,1:2]), cov(gdf[,1:2]))

ggplot(aes(x=Literacy, y=Crime_prop/1000, label=Department), data=gdf) +
  geom_point(size=2) +
  stat_ellipse(level=0.68, color="blue", size=1.2) +  
  stat_ellipse(level=0.95, color="gray", size=1, linetype=2) + 
  geom_smooth(method="lm", formula=y~x, fill="lightblue") +
  geom_smooth(method="loess", formula=y~x, color="red", se=FALSE) +
  geom_label_repel(data = gdf[gdf$dsq > 4.6,]) +
  theme_bw()
```

So, somewhat surprisingly, increased literacy is associated with an increase in property crime
(greater population per crime) as opposed to the situation with personal crime, which seems unrelated
to literacy.
Creuse again stands out as an unusual point, one that is likely to be influential in regression models.

## Reconnaisance plots

Reconnaisance plots attempt to give a bird's-eye overview of a multivariate data set.
For example, to see the relations among more than two variables we could turn to a
scatterplot matrix or some other display to show all pairwise bivariate relations. 


For these, my preferred package is `car` [@R-car] with the `scatterplotMatrix` function.
`GGally` [@R-GGally] works within the the `ggplot2` framework, but doesn't have the flexibility
I'd like.

```{r spm1}
#| out.width="100%",
#| echo=-1
par(mar=rep(2,4))
library(car)          # Companion to Applied Regression
scatterplotMatrix(Guerry[,4:9],
                  ellipse=list(levels=0.68), 
                  smooth=FALSE)
```

### Corrgrams

Sometimes, particularly with more variables than this, we want to see a more schematic overview.  
A _correlation diagram_ or "corrgram" [@Friendly:02:corrgram] is a graphic display of a correlation
matrix, allowing different renderings of the correlation between each pair of variables:
as a shaded box, a pie symbol, a schematic data ellipse, and other options.
This is implemented in the `corrgram` package [@R-corrgram].
The panels in the
upper and lower triangles can be rendered differently.

```{r corrgram1}
#| echo=-1
par(mar=rep(1,4)+.1)
library(corrgram)             # Plot a Correlogram
corrgram(Guerry[,4:9], upper=panel.pie)
```

Or, the data in each pairwise tile can be rendered with data ellipses and
smoothed curves to show possible nonlinear relations.

Another feature is that the rows/column variables can be permuted to 
put similar variables together, using the `order` option, which arranges the
variables according to similarity of their correlations. 


```{r corrgram2}
#| echo=-1
par(mar=rep(1,4)+.1)
corrgram(Guerry[,4:9], 
         upper=panel.ellipse, 
         order=TRUE,
         lwd=2)
```

Here, there are a number of
pairwise plots that appear markedly nonlinear. For the main crime variables, the most
nonlinear are that of personal crime vs. donations to the poor, and property crime vs.
infants born out of wedlock and suicides.
`Literacy` stands out here as having negative relations with all other variables.


An alternative analysis might include:

* converting the data to ranks.
* considering transformations of some of the variables


## Biplots

Rather than viewing the data in **data space**, a biplot shows the data in the **reduced-rank PCA space** that explains most of the variation of the observations.  This is essentially a plot of the observation scores on the first principal component overlaid with vectors representing the variables projected into PCA space.

First, we use `prcomp()` to carry out the PCA. We'd like to visualize the result in relation to `Region`, so
delete Corsica where `Region` is missing.

```{r guerry.pca}
gdata <- Guerry |>
  select(Region, Crime_pers:Suicides) |>   # keep only main variables
  filter(!is.na(Region))                   # delete Corsica (Region==NA)

guerry.pca <- gdata |>
  select(-Region) |>
  prcomp(scale = TRUE)

print(guerry.pca, digits=3)

```

<!-- A screeplot shows the proportions of variance accounted for by each component. The results show that only 65% -->
<!-- of the variance is accounted for in two dimensions. -->

<!-- ```{r fig.height=4, fig.width=7} -->
<!-- ggs1 <- ggscreeplot(guerry.pca) + theme_bw() + geom_point(size=4) -->
<!-- ggs2 <- ggscreeplot(guerry.pca, type="cev") + theme_bw() + geom_point(size=4) -->
<!-- ggs1 + ggs2 -->
<!-- ``` -->

In the `ggplot2` framework, biplots can be produced by the `ggbiplot` package [@R-ggbiplot], but this package is not on
CRAN, so cannot be directly used in this vignette. Instead, the code below was run locally and the result
included.
```{r biplot1}
#| eval=FALSE
if(!require(ggbiplot)) remotes::install_github("vqv/ggbiplot")
library(ggbiplot) # A ggplot2 based biplot
ggbiplot(guerry.pca, groups=gdata$Region, 
         ellipse=TRUE,
         var.scale = 3, varname.size = 5) + 
  theme_bw() + 
  labs(color="Region") +
  theme(legend.position = c(0.1, 0.8))
```
```{r ggbiplot}
knitr::include_graphics("figures/ggbiplot.png")
```


This is OK, but there are many features of such plots that cannot be customized (line widths, colors, ... ). I prefer
those created using the `heplots` package.

```{r biplot2, out.width="95%"}
op <- par(mar=c(5,4,1,1)+.1)
cols = colorspace::rainbow_hcl(5)
covEllipses(guerry.pca$x, 
            group=gdata$Region, 
            pooled=FALSE, 
            fill=TRUE, fill.alpha=0.1,
            col=cols, 
            label.pos=c(3,0,1,1,3), 
            cex=2,
            xlim=c(-4,4), ylim=c(-4,4),
            xlab = "Dimension 1 (35.7 %)", 
            ylab = "Dimension 2 (20.0 %)",
            cex.lab=1.4
            )
points(guerry.pca$x, pch=(15:19)[Guerry$Region], col=cols[Guerry$Region])

candisc::vectors(guerry.pca$rotation, scale=5,  
                 col="black", lwd=3, cex=1.4, 
                 pos = c(4,2,4,2,2,2),
                 xpd=TRUE)
abline(h=0, v=0, col=gray(.70))
```

An interpretation can be read from both the directions of the variable arrows and the 
relative positions of the ellipses representing the scatter of the component scores
for the different regions.

* The first component is largely aligned positively with `Literacy` and negatively with
property crime, suicides and children born out of wedlock (`Infants`)
* The second dimension reflects mainly the correlation of personal crime and donations to
the poor.
* The South region is generally lower on PC2, the West, generally higher.
* The North stands out as being higher than the others on PC1; the West somewhat higher on PC2.



# Models

Here we illustrate:

* Model based plots for linear regression models predicting personal crime and property crime
* Multivariate analysis of variance (MANOVA) and HE plots for the joint relation of the crime variables to other predictors. 

## Predicting crime: Univariate regression

The simplest approach to predicting the crime variables would be to fit a separate
multiple regression to each.

```{r mra-models}
crime.mod1 <- lm(Crime_pers ~  Region + Literacy + Donations +  Infants + Suicides, data=Guerry)
crime.mod2 <- lm(Crime_prop ~  Region + Literacy + Donations +  Infants + Suicides, data=Guerry)
```

Tests for the predictors are best obtained using `car::Anova()` which gives **partial** (Type II)
tests, adjusting for other predictors, 
rather than the **sequential** (Type I) tests provided by `stats::anova()`

```{r mra-anova}
Anova(crime.mod1)
Anova(crime.mod2)
```

These are somewhat disappointing if you look only at the significance stars:
Only `Region` is significant for personal crime and only `Suicides` for property crime.
There is no evidence for the argument, supported by
the liberal hygenicists of Guerry's time, that increased `Literacy` would reduce crime.

For such models, we can understand the nature of the predicted effects using the
`effects` package. The (marginal) effect for a given term gives the predicted values,
averaging over all other terms in the model.

```{r mra-effect1-code}
#| eval=FALSE
plot(predictorEffects(crime.mod1, ~ Region + Literacy + Infants + Suicides), 
     lwd=2, main="")
```
```{r mra-effect1}
#| echo = FALSE
knitr::include_graphics("figures/mra-effect1.png")
```

Doing the same for property crime, we get:

```{r mra-effect2-code}
#| eval=FALSE
plot(predictorEffects(crime.mod2, ~ Region + Literacy + Infants + Suicides), 
     lwd=2, main="")
```
```{r mra-effect2}
#| echo = FALSE
knitr::include_graphics("figures/mra-effect2.png")
```


## Predicting crime: Multivariate regression

The two regression models can be fit together in a multivariate regression for both
crime variables jointly.

```{r manova1}
crime.mod <- lm(cbind(Crime_pers, Crime_prop) ~ 
                Region + Literacy + Donations +  Infants + Suicides, data=Guerry)
Anova(crime.mod)
```

As a quick check on the assumption that the residuals are bivariate normally distributed
and a check for outliers, a $\chi^2$ Q-Q plot graphs the squared Mahalanobis distances
of the residuals against the corresponding $\chi^2_2$ quantiles these would have in a
bivariate normal distribution. The data for Creuse stands out as a potential outlier.

```{r cqplot}
#| echo=-1
par(mar=c(3,3,1,1)+.1)
labels <- paste0(Guerry$dept,":", Guerry$Department)
cqplot(crime.mod, id.n=4, labels=labels)
```

### HE plots
Hypothesis-Error (HE) plots [@Friendly:2007:heplots; @FoxFriendlyMonette:09:compstat; @heplots] provide a convenient graphical summary of hypothesis tests in multivariate linear model. They plot a data ellipse for the residuals in the model, representing the $\mathbf{E}$ matrix in the test statistics (Roy's maximum root test,
Pillai and Hotelling trace criteria and Wilks' Lambda). Overlaid on this are $\mathbf{H}$
ellipses for each term in the model, representing the data ellipses for the fitted values.
Using Roy's test, these have a convenient interpretation: a term is significant _iff_ the
H ellipse projects anywhere outside the E ellipse. For a 1 df (regression) variable, the
H ellipse collapses to a line.

```{r heplot}
#| echo=-1
par(mar = c(3,3,1,1)+.1)
heplot(crime.mod, 
       fill=TRUE, fill.alpha=0.05, 
       cex=1.4, cex.lab=1.3 )
```

In this plot, the effect of `Suicides` is completely aligned with crimes against property.
The effect of `Region` is positively correlated with both types of crime. The means
for the regions show that the South of France is lower (worse) on personal crime; the other
regions vary most in property crime, with the North being lower and the Center being higher.

### Canonical plots
The HE plot displays these relations in **data space**. An alternative is provided by 
canonical discriminant analysis, which finds the weighted sums of the response variables
leading to the largest test statistics for the terms, which can be visualized in
**canonical space**.

The analysis below reflects the effect of `Region` in relation to both crime variables.

```{r candisc}
crime.can <- candisc(crime.mod)
crime.can
```

The HE plot for this analysis is shown below. Variable vector represent the correlations
of the crime variables with the canonical dimension.
```{r hecan}
#| echo=-1
par(mar = c(3,3,1,1)+.1)
heplot(crime.can, fill=TRUE, fill.alpha=0.1,
       var.col = "black", 
       var.cex = 1.3,
       cex=1.4, cex.lab=1.3)
```

This gives a simple interpretation of the differences in `Region` on the crime variables.
The first canonical dimension accounts for 83% of differences among the regions,
and this is nearly perfectly aligned with personal crime, with the largest difference
between the South and the other regions. The second canonical dimension, accounting
for the remaining 17%, is perfectly aligned with property crime.  On this dimension,
the North stands out compared to the other regions.

```{r write-bib, echo = FALSE}
# write a packages.bib file of the packages (.packages()) that have been used here
pkgs <- unique(c(to.cite, .packages()))
knitr::write_bib(pkgs, file = here::here("vignettes", "packages.bib"))
```

# References
